vassign(.(sb, dlong, dwide, timing, tdiff), unpack.tversky(
     "galaxy.sqlite", include.incomplete = F))

parse.freqs = function(v)
   {v = ordered(v, levels = char(0:4))
      # "?" and "N/A" entries become NAs.
    levels(v) = qw(Never, Rare, Stimes, Usual, Always)
    v}

sb = with(dwide, cbind(sb,
    pool = "mturk",
    minutes = round(digits = 1, 1/60 * (
        ss(timing, k == "honest")$received - ss(timing, k == "age")$received)),
    honest = num(honest),
    retest.fellatio_to = num(p.fellatio_to.2) - num(p.fellatio_to),
    retest.friend = num(p.friend.2) - num(p.friend),
    english,
    gender,
    cis = gender == "Male" | gender == "Female",
    age = num(age),
    education,
    income = ordered(num(income)),
    orient = factor(modlevels(orient, Pan = c("[FR] pansexual", "[FR] Pansexual")),
        levels = qw(Het, Gay, Bi, Pan, Ace, "?")),
    attract_to_f = suppressWarnings(num(attract_to_f)),
    attract_to_m = suppressWarnings(num(attract_to_m)),
    partners = num(sex_amount.total_m) + num(sex_amount.total_f) + num(sex_amount.total_ftm) + num(sex_amount.total_mtf),
    partners_f = num(sex_amount.total_f),
    partners_m = num(sex_amount.total_m),
    partners_year = num(sex_amount.year_m) + num(sex_amount.year_f) + num(sex_amount.year_ftm) + num(sex_amount.year_mtf),
    partners_year_f = num(sex_amount.year_f),
    partners_year_m = num(sex_amount.year_m),
    alcohol_freq = parse.freqs(alcohol_freq),
    odrugs_freq = parse.freqs(drugs_freq)))

# s1209 said "In the very first question I answered the questions as to my own gender incorrectly. I am FEMALE, not Male."
sb["s1209", "gender"] = "Female"

# s0738 said "I put 'not sure' on the question asking if sexually attracted to men accidentally. Correct answer is 'not at all'. Im absolutly heteralsexual."
sb["s0738", "attract_to_m"] = 0

# Unactionable correction?
#  s1201 said "Accidentally said I'd like sex with a family member. For the record, not true."

# Corrections to be made:
#  s0197 said in the comments "Sorry, I accidentally clicked that my current sexual partner is a woman. I meant to click man, not woman!"
#  s0660 said "Apologies for the 1 mistake where I accidentally clicked male as my dating partner." (But then, what was the right answer?)
#  s0704 said "I accidentally marked the person I am in a relationship with as a female, when in fact I meant to mark male"
#  s0840 said "I made a mistake on the question about my spouse: I clicked 'male' when I meant to click 'female.'"

xtizing = as.matrix(dwide[paste0("xtizing.",
    c("001", "009", "010", "019", "028", "036", "041", "044", "049", "065", "073", "084", "090", "092", "095", "112", "125", "143", "144", "152"))])
# s0865 said "Misclicked the wallet question.  Have not taken money out of a wallet."
xtizing["s0865", "xtizing.028"] = 1
xtizing = `class<-`(xtizing, "numeric") - 1
for (revcode.var in qw(xtizing.090, xtizing.125))
    xtizing[,revcode.var] = 3 - xtizing[,revcode.var]
sb$dinhib = rowSums(xtizing)

condom = dwide[paste0("condom_", qw(fellatio_rec, coitus_m, analpen_to_m, analpen_to_f, coitus_f, fellatio_to, analpen_rec))]
for (col in 1 : ncol(condom))
    condom[,col] = parse.freqs(condom[,col])

pref.items = qw(mast_solo_m, mast_solo_f, coitus_m, coitus_f, analpen_to_f, analpen_to_m, analpen_rec, fellatio_rec, fellatio_to, cunn_rec, cunn_to, anil_to_f, anil_to_m, anil_rec, mast_rec_m, mast_to_m, mast_rec_f, mast_to_f, bnip_rec, bnip_to, objpen_rec, objpen_to, hug, kiss, intimacy, love, control_to, control_rec, desired, pleasure_to, pain_to, pain_rec, bondage_to, bondage_rec, urine_to, urine_rec, leather, underwear, roleplay, insult_to, insult_rec, semen_to_mouth, semen_to_vag, semen_to_anus, semen_rec_mouth, semen_rec_vag, semen_rec_anus, semen_swallow, group_sex, rape_to, rape_rec, porn_written, porn_visual, porn_video_mf, porn_video_ff, porn_video_mm, voyeur_known, voyeur_secret, exhibit, incest, in_rship, friend, recent_acq, stranger, uncon, penis_big, penis_small, breasts_big, breasts_small, butt_big, butt_small, feet_big, feet_small, feet, man, man_fem, man_mas, man_trans, woman, woman_fem, woman_mas, woman_trans, age_08, age_14, age_70, rich, rebel, experienced, virgin, persity_eh, persity_al, persity_ch, persity_nh, persity_oh, persity_el, persity_ah, persity_cl, persity_nl, persity_ol)
pref.items.m = qw(mast_solo_m, coitus_m, analpen_to_f, analpen_to_m, fellatio_rec, mast_rec_m, semen_to_mouth, semen_to_vag, semen_to_anus)
pref.items.f = qw(mast_solo_f, coitus_f, cunn_rec, mast_rec_f, semen_rec_vag)
pref.items.v2 = qw(bnip_rec, bnip_to, underwear, roleplay, exhibit)

prefs = with(ss(dlong, k %in% paste0("p.", pref.items)), data.frame(
    s,
    item = factor(substr(k, 3, 1e6), levels = pref.items),
    pref = num(v)))
prefs = ordf(prefs, s, item)
# s0317 wrote in the comments: "I answered next to last for the question about raping somebody but I meant to choose the very last option"
prefs[with(prefs, which(s == "s0317" & item == "rape_to")), "pref"] = 1

prefwide.all = dcast(prefs, s ~ item, value.var = "pref")
prefwide.all = `row.names<-`(prefwide.all[,-1], char(prefwide.all[,1]))

pwu = transform(prefwide.all,
  # (p)ref(w)ide (u)nisex
    mast_solo = ifna(mast_solo_m, mast_solo_f),
    mast_rec = ifna(mast_rec_m, mast_rec_f),
    coitus = ifna(coitus_m, coitus_f),
    mast_to = pmax(mast_to_m, mast_to_f),
    #analpen_to = pmax(analpen_to_m, analpen_to_f),
      # Only men can do that, anyway.
    anil_to = pmax(anil_to_m, anil_to_f))
pwu = pwu[setdiff(colnames(pwu), c(pref.items.m, pref.items.f, qw(
    mast_to_m, mast_to_f,
    anil_to_m, anil_to_f,
    # These should be covered by porn_visual.
    porn_video_mf, porn_video_ff, porn_video_mm)))]
pwu.items = colnames(pwu)

pref.item.medians = mapcols(prefwide.all, function(v) median(v, na.rm = T))
sb$prefmad = rowMeans(na.rm = T, abs(
    sweep(prefwide.all, MARGIN = 2, pref.item.medians, `-`)))
sb$prefmad.q = ecdf(sb$prefmad)(sb$prefmad)

itemgroups = list(
    "Social distance from partners" = c(
        love = "Love ✔",  # F somewhat more likely to choose 7
        intimacy = "Intimacy ✔",  # similar to ~love~
        kiss = "Kissing ✔",  # F more likely to choose 7
        hug = "Hugging ✔",  # F higher
        in_rship = "With relationship partner ✔",  # similar to ~love~
        friend = "With friend ✔",  # M higher
        recent_acq = "With acquaintance ✔",  # M about uniform, F mode 1
        stranger = "With stranger ✔",  # M about uniform, F mode 1
        group_sex = "Group sex ✔",  # M mode 7, F mode 1
        mast_solo = "Solo masturbation ✖"),  # F mode 7, M mode 4
    "Power dynamics with partners" = c(
        rebel = "With rebel ✖",  # M slightly higher
        rape_rec = "Being raped ✔",  # F higher
        rape_to = "Raping ✔",  # M higher
        control_rec = "Being controlled ✔",  # F mode 7, M mode 1
        control_to = "Controlling ✔",  # M mode 7, F mode 1 (but close to uniform for both
        bondage_rec = "Being tied up ✔",  # F mode 7, M mode 1
        bondage_to = "Tying up ✖",  # F slightly higher
        exhibit = "Exhibition ✔",  # both about uniform, but F is more polarized
        voyeur_known = "Voyeurism, known ✔",  # M mode 7, F mode 1 (but close to uniform for both)
        voyeur_secret = "Voyeurism, secret ✔",  # M about uniform, F mode 1
        insult_to = "Insulting partner ✔",  # M higher
        insult_rec = "Being insulted ✖",  # M dislike less
        urine_to = "Urinating on partner ✔",  # M higher
        urine_rec = "Being urinated on ✖",  # M higher
        uncon = "With unconscious partner ✔",  # M higher
        age_70 = "With 70-year-old ✔",  # M higher
        age_08 = "With 8-year-old ✔",  # M higher
        incest = "Incest ✔",  # M higher
        pain_rec = "Pain ✔",  # F dislike less
        pain_to = "Causing pain ✔"),  # M higher
    "Reproductive health of partners" = c(
        age_14 = "With 14-year-old ✔",  # M higher
        feet_small = "Small feet ✔",  # M higher
        feet_big = "Big feet ✖",  # M slightly higher
#        butt_small = "Small butt",  # M dislike less
          # Commented out since, come to think of it,
          # we don't really have a theoretical prediction.
        butt_big = "Big butt ✔"),  # M mode 7, F mode 1
    "Sexual experience of partners" = c(
        experienced = "With experienced partner ✖", # M slightly higher
        virgin = "With virgin ✔"),  # M mode 7, F mode 1
    "Pornography" = c(
        porn_written = "Porn, written ✔",  # F higher
        porn_visual = "Porn, visual ✔"),  # M higher
    "Additional items" = c(
        rich = "With rich person ✖",  # M slightly higher
        desired = "Being desired ✔",  # M choose 6s (vs. 7s) about twice as often
        pleasure_to = "Giving pleasure ✔"))  # F slightly more likely to choose 7

pretty.item.names = c(
    mast_solo_m =	"Solo masturbation",
    mast_solo_f =	"Solo masturbation",
    coitus_m =		"Coitus",
    coitus_f =		"Coitus",
    analpen_to_f =	"Penis in woman's anus",
    analpen_to_m =	"Penis in man's anus",
    analpen_rec =	"Receiving penis in anus",
    fellatio_rec =	"Being fellated",
    fellatio_to =	"Fellating",
    cunn_rec =		"Receiving cunnilingus",
    cunn_to =		"Giving cunnilingus",
    anil_to_f =		"Giving a woman anilingus",
    anil_to_m =		"Giving a man anilingus",
    anil_rec =		"Receiving anilingus",
    mast_rec_m =	"Being masturbated",
    mast_to_m =		"Masturbating a man",
    mast_rec_f =	"Being masturbated",
    mast_to_f =		"Masturbating a woman",
    bnip_rec =		"Receiving breast stimulation",
    bnip_to =		"Giving breast stimulation",
    objpen_rec =	"Being penetrated by object",
    objpen_to =		"Penetrating with object",
    hug =		"Hugging",
    kiss =		"Kissing",
    intimacy =		"Emotional closeness",
    love =		"Feeling in love",
    control_to =	"Controlling",
    control_rec =	"Being controlled",
    desired =		"Being sexually desired",
    pleasure_to =	"Giving pleasure",
    pain_to =		"Causing pain",
    pain_rec =		"Receiving pain",
    bondage_to =	"Tying up",
    bondage_rec =	"Being tied up",
    urine_to =		"Urinating on partner",
    urine_rec =		"Being urinated on",
    leather =		"Leather",
    underwear =		"Underwear",
    roleplay =		"Role-playing",
    insult_to =		"Insulting",
    insult_rec =	"Being insulted",
    semen_to_mouth =	"Ejaculating into mouth",
    semen_to_vag =	"Ejaculating into vagina",
    semen_to_anus =	"Ejaculating into anus",
    semen_rec_mouth =	"Receiving semen in mouth",
    semen_rec_vag =	"Receiving semen in vagina",
    semen_rec_anus =	"Receiving semen in anus",
    semen_swallow =	"Swallowing semen",
    group_sex =		"Group sex",
    rape_to =		"Raping",
    rape_rec =		"Being raped",
    porn_written =	"Porn stories",
    porn_visual =	"Porn videos or pictures",
    porn_video_mf =	"Porn video, male-female",
    porn_video_ff =	"Porn video, female-female",
    porn_video_mm =	"Porn video, male-male",
    voyeur_known =	"Voyeurism in open",
    voyeur_secret =	"Voyeurism in secret",
    exhibit =		"Exhibitionism",
    incest =		"Incest",
    in_rship =		"Sex in relationship",
    friend =		"Friend",
    recent_acq =	"Acquaintance",
    stranger =		"Stranger",
    uncon =		"Unconscious partner",
    penis_big =		"Large penis",
    penis_small =	"Small penis",
    breasts_big =	"Large breasts",
    breasts_small =	"Small breasts",
    butt_big =		"Large buttocks",
    butt_small =	"Small buttocks",
    feet_big =		"Large feet",
    feet_small =	"Small feet",
    feet =		"Feet",
    man =		"Man",
    man_fem =		"Feminine man",
    man_mas =		"Masculine man",
    man_trans =		"FtM",
    woman =		"Woman",
    woman_fem =		"Feminine woman",
    woman_mas =		"Masculine woman",
    woman_trans =	"MtF",
    age_08 =		"8-year-old",
    age_14 =		"14-year-old",
    age_70 =		"70-year-old",
    rich =		"Rich partner",
    rebel =		"Rebel",
    experienced =	"Experienced partner",
    virgin =		"Virgin",
    persity_eh =	"Extraverted partner",
    persity_al =	"Disagreeable partner",
    persity_ch =	"Conscientious partner",
    persity_nh =	"Neurotic partner",
    persity_oh =	"Open partner",
    persity_el =	"Introverted partner",
    persity_ah =	"Agreeable partner",
    persity_cl =	"Unconscientious partner",
    persity_nl =	"Non-neurotic partner",
    persity_ol =	"Non-open partner")
