


kcluster = function(m, max.to.join, cluster.dist.f = max, max.clusters = Inf)
# Let k be the number of variables.
# m: A k × k matrix of distances.
## dists: A choose(k, 2) × 3 data frame. The first two columns
##   "v1" and "v2" give a pair of variables and the third "dist"
##   gives the distance.
   {pairds = data.frame(t(combn(row.names(m), 2)))
    pairds$dist = sapply(1 : nrow(pairds), function(i)
        m[char(pairds[i, 1]), char(pairds[i, 2])])
    pairds = ordf(pairds, dist)
    vs1 = char(pairds[,1])
    vs2 = char(pairds[,2])
    vs = unique(c(recursive = T, lapply(seq_along(vs1), function(i)
        if (rbinom(1, 1, .5)) c(vs1[i], vs2[i]) else c(vs2[i], vs1[i]))))

    clusters = list()
    for (v in vs)
       {cluster.dists = num(lapply(clusters, function(cluster.vs)
           {dists = sapply(cluster.vs, function(other) m[v, other])
            cluster.dist.f(dists)}))
        if (!any(cluster.dists <= max.to.join))
          # Create a new cluster for this variable, so long as we
          # don't exceed max_clusters. Otherwise it gets thrown
          # away.
           {if (length(clusters) < max.clusters)
                clusters = c(clusters, list(v))}
        else
          # Add the variable to the nearest cluster.
           {nearest = which.min(cluster.dists)
            clusters[[nearest]] = c(clusters[[nearest]], v)}}
    clusters[order(-sapply(clusters, length))]}

go = function(gender)
   {pw = ss(prefwide, sb[row.names(prefwide), "gender"] == gender)
    pw = pw[sapply(pref.items, function(pi)
        all(!is.na(pw[pi])) && var(pw[pi]) > 0)]
    pk = cor(pw, method = "kendall")
    pd = -pk + 1
    list(pk, kcluster(pd, max.to.join = .5))}

go2 = function()
   {pw = ss(prefwide, sb[row.names(prefwide), "gender"] == gender)
    pw = pw[sapply(pref.items, function(pi)
        all(!is.na(pw[pi])) && var(pw[pi]) > 0)]
    pd = sapply(names(pw), function(v1) sapply(names(pw), function(v2)
        mean((pw[,v1] - pw[,v2])^2)))
    list(pd, kcluster(pd,
        max.to.join = num(quantile(pd, 1/5)),
        max.clusters = 5))}
