trivial.input = function(s)
   {s = gsub("\\W", "", tolower(s))
    s %in% c("", "no", "nope", "none", "nonone", "na", "nocomment", "nocomments")}

strs = function(s, preferences_other, comments)
    for (i in seq_along(s))
       {if (trivial.input(preferences_other[i]) && trivial.input(comments[i]))
            next
        cat("- ", char(s[i]), "\n", sep = "")
        if (!trivial.input(preferences_other[i]))
            cat("  - Other preferences: ", preferences_other[i], "\n", sep = "")
        if (!trivial.input(comments[i]))
            cat("  - Comments: ", comments[i], "\n", sep = "")}

hclust.kendall.abs = function(gender)
   cache(list(gender), cache.dirs = c("Kodi", "projects", "galaxy"), comment = paste("go.hclust.kendall.abs", gender), v =
      {pw = prefwide[sb[row.names(prefwide), "gender"] == gender,]
       items = pref.items[unname(sapply(pref.items, function(pi)
           #!grepl("semen", pi, fixed = T) &&
           all(!is.na(pw[pi])) &&
           var(pw[pi]) > 0))]
       pw = pw[,items]
       pk = abs(cor(pw, method = "kendall"))
       pd = as.dist(1 - pk)
       list(dat = pw, dists = pd, tree = hclust(pd, method = "average"))})

score.nll2 = function(pred.probs, outcomes)
    mean(-log(base = 2, ifelse(outcomes, pred.probs, 1 - pred.probs)))
