
predwithpref.onegender.normal = function(ses, y, gend, y.min = -Inf, y.max = Inf)
   {y = y[sb[ses, "gender"] == gend]
    ses = ses[sb[ses, "gender"] == gend]

    iv = as.matrix(remove.na.prefwide.cols(prefwide[ses,]))
    pred = crossvalid(iv, y, nfold = 10, f = function(train.iv, train.dv, test.iv)
       {m = cv.glmnet(train.iv, train.dv,
            family = "gaussian",
            alpha = 0, # Ridge regression
            type.measure = "mse")
        predict(m, newx = test.iv, type = "response", s = "lambda.min")})
    pred = pmin(y.max, pmax(y.min, pred))

    data.frame(
        row.names = paste(gend, qw(baseline, model)),
        RMSE = c(
            sdn(y),
            sqrt(mean( (pred - y)^2 ))))}

predwithpref.bygender.normal = function(ses, y, ...)
    do.call(rbind, lapply(qw(Male, Female), function(gend)
        predwithpref.onegender.normal(ses, y, gend, ...)))

predwithpref.onegender.logit = function(ses, y, gend)
   {y = y[sb[ses, "gender"] == gend]
    ses = ses[sb[ses, "gender"] == gend]

    iv = as.matrix(remove.na.prefwide.cols(prefwide[ses,]))
    pred = crossvalid(iv, y, nfold = 10, f = function(train.iv, train.dv, test.iv)
       {m = cv.glmnet(train.iv, train.dv,
            family = "binomial",
            alpha = 0, # Ridge regression
            type.measure = "deviance")
        predict(m, newx = test.iv, type = "response", s = "lambda.min")})

    data.frame(
        row.names = paste(gend, qw(baseline, model)),
        Accuracy = c(
            num(max(prop.table(table(y)))),
            mean((pred > .5) == y)),
        NLL2 = c(
            score.nll2(mean(y), y),
            score.nll2(pred, y)))}

predwithpref.bygender.logit = function(ses, y)
    do.call(rbind, lapply(qw(Male, Female), function(gend)
        predwithpref.onegender.logit(ses, y, gend)))

predwithpref.bothgenders.logit = function(ses, y)
   {y = y[sb[ses, "cis"]]
    ses = ses[sb[ses, "cis"]]

    gender = factor(sb[ses, "gender"])
    iv = cbind(
        female = gender == "Female",
        scale(as.matrix(prefwide[ses, setdiff(pref.items, pref.items.v2)])))
    iv[is.na(iv)] = 0

    pred = crossvalid(iv, y, nfold = 10, f = function(train.iv, train.dv, test.iv)
       {m = cv.glmnet(train.iv, train.dv,
            family = "binomial",
            alpha = 0, # Ridge regression
            type.measure = "deviance",
            standardize = F)
        predict(m, newx = test.iv, type = "response", s = "lambda.min")})
    data.frame(
        row.names = qw(baseline, model),
        Accuracy = c(
            num(max(table(y[gender == "Male"])) + max(table(y[gender == "Female"]))) /
                length(y),
            mean((pred > .5) == y)),
        NLL2 = c(
            score.nll2(
                ifelse(gender == "Male",
                    mean(y[gender == "Male"]),
                    mean(y[gender == "Female"])),
                y),
            score.nll2(pred, y)))}
