library(reshape2)
library(plyr)
library(stringr)
library(DBI)
library(RSQLite)
library(R.cache)
library(ggplot2)
library(glmnet)
library(psych)
library(e1071)

sys.source(getOption("Kodi.R.path"), Kodi <- new.env())
for (name in Kodi$qw(
        qw, rd, ordf, dfn, ss, df2nv, vassign, char, num, qmean, mad1, sdn,
        punl, ifna,
        maprows, mapcols, modlevels, revn, sdn,
        crossvalid, which.min.hastie, discrete.hdi,
        unpack.tversky, tversky.sid, posix.ct,
        lapply.names,
        dodge, boxp, no.gridlines,
        daylight.autos, cache
      ))
    assign(name, Kodi[[name]])
cached = Kodi$mk.cached(c("Kodi", "projects", "galaxy"))

# --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# Suboordinate files
# --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

source("data.R", local = T)
source("export.R", local = T)
source("cluster-prediction.R", local = T)
source("plotting.R", local = T)
source("misc.R", local = T)
daylight.autos("notebook.org")

# Finding free-response items:
#  names(sort(sapply(dwide[,-1], function(v) max(nchar(v))), dec = T))[1:8]
